/// @cond EO_CXX_EO_IMPL

inline void elm::hoversel_item::icon_get(const char ** icon_file_, const char ** icon_group_, Elm_Icon_Type* icon_type_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_item_icon_get(icon_file_, icon_group_, icon_type_));
}

inline void elm::hoversel_item::icon_set(::efl::eina::optional< ::efl::eina::string_view > icon_file_, ::efl::eina::optional< ::efl::eina::string_view > icon_group_, Elm_Icon_Type icon_type_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_item_icon_set(::efl::eolian::to_c(icon_file_), ::efl::eolian::to_c(icon_group_), icon_type_));
}

inline void eo_cxx::elm::hoversel_item::icon_get(const char ** icon_file_, const char ** icon_group_, Elm_Icon_Type* icon_type_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_item_icon_get(icon_file_, icon_group_, icon_type_));
}

inline void eo_cxx::elm::hoversel_item::icon_set(::efl::eina::optional< ::efl::eina::string_view > icon_file_, ::efl::eina::optional< ::efl::eina::string_view > icon_group_, Elm_Icon_Type icon_type_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_item_icon_set(::efl::eolian::to_c(icon_file_), ::efl::eolian::to_c(icon_group_), icon_type_));
}

inline ::eo_cxx::elm::hoversel_item::operator ::elm::hoversel_item() const
{
   return *static_cast<::elm::hoversel_item const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::hoversel_item::operator ::elm::hoversel_item&()
{
   return *static_cast<::elm::hoversel_item*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::hoversel_item::operator ::elm::hoversel_item const&() const
{
   return *static_cast<::elm::hoversel_item const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_hoversel_item_icon_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char ** icon_file_, const char ** icon_group_, Elm_Icon_Type* icon_type_)
{
   try
      {
         static_cast<T*>(self->this_)->icon_get(icon_file_, icon_group_, icon_type_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_hoversel_item_icon_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * icon_file_, const char * icon_group_, Elm_Icon_Type icon_type_)
{
   try
      {
         static_cast<T*>(self->this_)->icon_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(icon_file_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(icon_group_, std::tuple<std::false_type>()), icon_type_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::hoversel_item >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget_item >::template type<T>
   {
      virtual void icon_get(const char ** icon_file_, const char ** icon_group_, Elm_Icon_Type* icon_type_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_hoversel_item_icon_get(icon_file_, icon_group_, icon_type_));
      }

      virtual void icon_set(::efl::eina::optional< ::efl::eina::string_view > icon_file_, ::efl::eina::optional< ::efl::eina::string_view > icon_group_, Elm_Icon_Type icon_type_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_hoversel_item_icon_set(::efl::eolian::to_c(icon_file_), ::efl::eolian::to_c(icon_group_), icon_type_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::hoversel_item >
{
   static constexpr int value = 
#if defined(HOVERSEL_ITEM_PROTECTED) && defined(HOVERSEL_ITEM_BETA)
      2
#elif defined(HOVERSEL_ITEM_PROTECTED)
      2
#elif defined(HOVERSEL_ITEM_BETA)
      2
#else
      2
#endif
      + operation_description_class_size<::elm::widget_item >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::hoversel_item>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_item_icon_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_item_icon_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_item_icon_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_item_icon_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget_item>(), &ops[operation_description_class_size< ::elm::hoversel_item >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::hoversel_item>)
{
   return (ELM_HOVERSEL_ITEM_CLASS);
}

} } }

/// @endcond

